unit Unit_TreeThemes;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.ExtCtrls,
  VCLTee.TeeProcs, TeeTree, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Tree1: TTree;
    LBVCLThemes: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure LBVCLThemesClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Vcl.Themes, Vcl.Styles;

procedure TForm1.FormCreate(Sender: TObject);

  procedure SetThemes(const AItems: TStrings);
  {$IFNDEF FPC}
  {$IF CompilerVersion>=23}
  var s : String;
  {$IFEND}
  {$ENDIF}
  begin
    AItems.BeginUpdate;
    try
      AItems.Clear;

      {$IFNDEF FPC}
      {$IF CompilerVersion>=23}
      for s in TStyleManager.StyleNames do
          AItems.Add(s);
      {$IFEND}
      {$ENDIF}
    finally
      AItems.EndUpdate;
    end;
  end;

var i, j: Integer;
begin
  SetThemes(LBVCLThemes.Items);

  for i:=0 to 9 do
  begin
    Tree1.AddRoot('Root ' + IntToStr(i+1)).Font.Color:=StyleServices(Self).GetStyleFontColor(sfTextLabelNormal);

    for j:=0 to 9 do
       Tree1.Roots[i].AddChild('Child ' + IntToStr(j+1));
  end;

end;

procedure TForm1.LBVCLThemesClick(Sender: TObject);
var tmp: String;
    tmpStyle: TCustomStyleServices;
    tmpFontColor, tmpBrush, tmpStroke: TColor;
    i, j: Integer;
begin
  if LBVCLThemes.ItemIndex<>-1 then
  begin
    tmp:=LBVCLThemes.Items[LBVCLThemes.ItemIndex];
    TStyleManager.SetStyle(tmp);

    tmpStyle:=TStyleManager.ActiveStyle;
    if tmpStyle<>nil then
    begin
      tmpFontColor:=tmpStyle.GetStyleFontColor(TStyleFont.sfEditBoxTextNormal);
      tmpBrush:=tmpStyle.GetStyleColor(TStyleColor.scEdit);
      tmpStroke:=tmpStyle.GetStyleColor(TStyleColor.scBorder);

      Tree1.Color:=tmpStyle.GetStyleColor(TStyleColor.scPanel);

      for i:=0 to Tree1.Items.Count-1 do
      begin
        Tree1[i].Font.Color:=tmpFontColor;
        Tree1[i].Color:=tmpBrush;

        for j:=0 to Tree1[i].Connections.Count-1 do
        begin
          Tree1[i].Connections[j].Border.Color:=tmpStroke;
          Tree1[i].Connections[j].Border.SmallDots:=False;
          Tree1[i].Connections[j].Border.Style:=psSolid;
        end;
      end;
    end;
  end;
end;

end.
